=== debian/changelog ===
cp2k (2.3.0-1) unstable; urgency=low

  * New upstream release.  New features include:
    + MP2 energies
    + Double-hybrid XC functionals including B2PLYP and B2GPPLYP
    + Self-Consistent-Polarization Tight-Binding (SCP-TB) method
    + Periodic Restrained Electrostatic Potential (RESP) charge fitting
    + Slater-type orbitals in the atomic code
    + Electron Localization Functions (ELF)
  * debian/patches/fortran_continuing_lines.patch: Refreshed.
  * debian/patches/reset_cppflags_makdepf90.patch: Likewise.
  * debian/control (Description): Updated.
  * debian/patches/makeflags.patch: Undefine CPP variable (Closes: #701263).
  * debian/patches/gcc-4.8_fixes.patch: New patch, fixes a build failure with
    gfortran-4.8, taken from upstream revision 12562.
  * debian/rules (override_dh_auto_test): Select less expensive tests where
    applicable and include some more tests for wider coverage.
  * debian/cp2k-data.install: Added tests/QS/t_sh_p_s_c.dat.
  * debian/control (Build-Depends): Added bc, used to calculate runtimes in the
    testsuite.

 -- Michael Banck <mbanck@debian.org>  Fri, 05 Jul 2013 14:00:40 +0200
